<script lang="ts">
  import { flip } from "svelte/animate";
  import PlayerC from "./components/Player.svelte";
  import Rankings from "./components/Rankings.svelte";
  import TileC from "./components/Tile.svelte";
  import {
    getCenter,
    getColor,
    getFactories,
    getGroup,
    isActive,
    isColored,
    withUserLast,
  } from "./util";

  export let state: GameState;
  export let playerId: PlayerId | null;

  $: players = withUserLast(state.players, playerId);

  let user: Player | null;
  $: user = players.find((p) => p.id === playerId) ?? null;

  $: factories = getFactories(state);

  $: centerTiles = getCenter(state);

  $: userIsPicking = state.phase[0] === "Picking" && isActive(state, playerId);

  let selectedTile: ColoredTile | null = null;

  let selectedTileGroup: "center" | number | null = null;
  $: selectedTileGroup =
    selectedTile !== null ? getGroup(state, selectedTile) : null;

  function getFactoryTransform(idx: number): string {
    const rotation = (360 / factories.length) * idx;
    const radius = `${factories.length * 0.8 + 6.5}`;
    return `transform: translate(-50%, -50%) rotate(${rotation}deg) translateY(-${radius}em) rotate(-${rotation}deg);`;
  }

  function getPlayerTransform(idx: number): string {
    const size = players.length;
    const rotationRad = ((2 * Math.PI) / size) * ((idx + 1) % size);
    const radius =
      Math.abs(Math.cos(rotationRad)) * 3 + ((size - 2) / 2) * 5 + 21;

    return `
      --player-rotation: ${rotationRad}rad;
      --player-radius: ${radius}em;
    `;
  }
</script>

<section>
  <div
    class="center"
    style={`width: ${Math.ceil(Math.sqrt(centerTiles.length)) * 3}em;`}
  >
    {#each centerTiles as tile (tile)}
      <div
        class="tile"
        class:selected={selectedTile !== null &&
          selectedTileGroup === "center" &&
          (tile === "s" ||
            (isColored(tile) && getColor(tile) === getColor(selectedTile)))}
        animate:flip={{ duration: 500 }}
      >
        <label>
          <input
            disabled={tile === "s"}
            type="radio"
            name="tile"
            bind:group={selectedTile}
            value={tile}
          />
          <TileC {tile} />
        </label>
      </div>
    {/each}
  </div>
  {#if state.phase[0] === "Tiling"}
    <div class="phase-description">
      <p><em>Players are placing tiles and scoring points.</em></p>
      <p>
        <gs6-user userid={state.phase[1].first} />
        is the starting player next round.
      </p>
    </div>
  {:else if state.phase[0] === "Complete"}
    <div class="phase-description rankings panel border shadow">
      <Rankings players={state.players} phase={state.phase[1]} />
    </div>
  {/if}
  {#each factories as factory, idx (idx)}
    <div style={getFactoryTransform(idx)} class="factory panel border shadow">
      {#each factory as tile (tile)}
        <div
          class="tile"
          class:selected={selectedTile !== null &&
            selectedTileGroup === idx &&
            isColored(tile) &&
            getColor(tile) === getColor(selectedTile)}
          animate:flip
        >
          <label>
            <TileC {tile} />
            <input
              type="radio"
              name="tile"
              bind:group={selectedTile}
              value={tile}
              disabled={!userIsPicking}
            />
          </label>
        </div>
      {/each}
    </div>
  {/each}

  {#each players as player, idx (player.id)}
    <div
      class="player"
      class:is-user={playerId === player.id}
      style={getPlayerTransform(idx)}
      animate:flip={{ duration: 500 }}
    >
      <div>
        <PlayerC {user} {state} {player} {selectedTile} on:action />
      </div>
    </div>
  {/each}
</section>

<style>
  section {
    height: 100%;
    position: relative;

    --board-background-color: hsl(34deg 60% 84%);
    --board-border-color: hsl(34 10% 25% / 0.25);
  }
  .center {
    position: absolute;
    top: 50%;
    left: 50%;

    transform: translate(-50%, -50%);

    display: flex;
    flex-wrap: wrap;
    place-content: center;
  }

  .factory {
    position: absolute;
    top: 50%;
    left: 50%;

    padding: 1.25rem;

    border-radius: 100%;
    background-color: var(--board-background-color);
    border-color: var(--board-border-color);

    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-template-rows: 1fr 1fr;
  }

  .tile {
    display: grid;
    place-content: center;
    font-size: 1.75em;
    padding: 0.25rem;
  }
  .tile > label {
    position: relative;
    border-radius: 0.2em;
  }

  .tile > label > input {
    position: absolute;
    opacity: 0;
    margin: 0;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }
  .tile > label > input:not(:disabled) {
    cursor: pointer;
  }

  .tile.selected > label {
    outline: 3px solid #0085ff;
    outline-offset: 2px;
  }

  .player {
    position: absolute;
    top: 50%;
    left: 50%;

    display: flex;
    flex-direction: column;
    align-items: center;
    transform: translate(-50%, -50%) rotate(var(--player-rotation))
      translateY(var(--player-radius)) rotate(calc(-1 * var(--player-rotation)));

    padding-bottom: 7.25rem; /* to cover the player board */
  }
  .player.is-user {
    padding-bottom: 12rem;
  }

  .player > div {
    position: relative;
  }

  .phase-description {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    text-align: center;
  }
  .phase-description em {
    font-weight: 300;
  }

  .rankings {
    z-index: 100;
  }
  .player:hover {
    z-index: 200;
  }
</style>
